unit Graph_256_Bezi;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TPixel = array [1..2] of Integer;
  TPoint = array [1..2] of Double;
  TArrayOfPoints = array [0..500] of TPoint;
  TDraw2D = class(TForm)
    Panel1: TPanel;
    Image1: TImage;
  procedure BeziereCurve(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  Procedure ClearData(Sender:TObject);
  procedure SetBeziere(Sender: TObject);
  private
    { Private declarations }
     PointOnScanRow: PByteArray;
  public
    { Public declarations }

    {Nastaven velikosti obrazu a hloubky pixelu}
    Procedure InitImage(Width,Height:Integer);
    {nastaven barvy z barevnch sloek}
    Procedure ClearImage(Color:Byte);
    {Nastaven uivatelskch rozmr kreslc plochy}
    procedure Scale(x1,x2,y1,y2:Double);
    {Pepoet prvn uivatelsk souadnice na svtovou}
    function  XCoor(x:Double):integer;
    {Pepoet druh uivatelsk souadnice na svtovou}
    function  YCoor(y:Double):integer;
    {Pepoet prvn svtov souadnice na uivatelskou}
    function  InvXCoor(x:Integer):Double;
    {Pepoet druh svtov souadnice na uivatelskou}
    function  InvYCoor(y:Integer):Double;
    {Sestroj bod ve svtovch souadnicch zadanou barvou}
    procedure PutPixel(X:TPixel;Color:Byte);
    {Sestroj seku ve svtovch souadnicch zadanou barvou}
    procedure PixelLine(X,Y:TPixel;Color:Byte);
     {Sestroj kek na uivatelskch souadnicch zadanou barvou}
    Procedure Cross(X:TPoint;Size,Color:Byte);
    {Sestroj seku v uivatelskch souadnicch zadanou barvou}
    procedure Line(X,Y:TPoint;Color:Byte);
   {Sestroj polygon prochzenc prvnmi n body zadanho pole zadanou barvou}
    procedure PolyLine(X:TArrayOfPoints;n:Word;Color:Byte);
  end;

 const
    { Colors Milenium Edition

     slBlack=0;
     slMaroon=1;
     slGreen=2;
     slOlive=3;
     slNavy=4;
     slPurple=5;
     slTeal=6;
     slGray=12;
     slSilver=7;
     slRed=13;
     slLime=14;
     slYellow=15;
     slBlue=16;
     slFuchsia=17;
     slAqua=18;
     slWhite=19; }

   { Colors XP }
 
     slBlack=0;
     slMaroon=1;
     slGreen=2;
     slOlive=3;
     slNavy=4;
     slPurple=5;
     slTeal=6;
     slGray=18;
     slSilver=7;
     slRed=32;
     slLime=29;
     slYellow=94;
     slBlue=61;
     slFuchsia=128;
     slAqua=190;
     slWhite=255;


 var
  Draw2D: TDraw2D;
  Red,Green,Blue:Byte;
  Unit_X,Unit_Y:Real;
  O            :TPoint;
  x1,x2,y1,y2  :Real;
  index        :Integer;
  C            :TArrayOfPoints;
  P            :array [0..3] of TPoint;
  FirstArc     :Boolean;

implementation

{$R *.DFM}

Procedure TDraw2D.InitImage(Width,Height:Integer);
begin
      Image1.Align:=alNone;
      Image1.Picture.Bitmap.PixelFormat:=pf8bit;
      Image1.Picture.Bitmap.Width:=Width;
      Image1.Picture.Bitmap.Height:=Height;
      Image1.Width:=Width;
      Image1.Height:=Height;
      Visible:=True;
end;

Procedure TDraw2D.ClearImage(Color:Byte);
var i,j:Integer;
begin
  With Image1 do
  for j:=0 to Height-1 do
  begin
    PointOnScanRow:=Picture.Bitmap.ScanLine[j];
    for i:=0 to Width-1 do PointOnScanRow[i]:=Color;
  end;
  Image1.REpaint;
end;

Procedure TDraw2D.Scale(x1,x2,y1,y2:Double);
  begin
     Unit_X:= Image1.Width/(x2-x1);
     Unit_Y:= Image1.Height/(y2-y1);
     O[1]  := -x1*Unit_X;
     O[2]  :=  y2*Unit_Y;
  end;

  function  TDraw2D.XCoor(x:Double):integer;
  begin
    XCoor:=trunc(O[1]+Unit_X*x);
  end;

  function  TDraw2D.YCoor(y:Double):integer;
  begin
     YCoor:=trunc(O[2]-Unit_Y*y);
  end;

  function  TDraw2D.InvXCoor(x:Integer):Double;
  begin
    InvXCoor:=(x-O[1])/Unit_X;
  end;

  function  TDraw2D.InvYCoor(y:Integer):Double;
  begin
     InvYCoor:=(O[2]-y)/Unit_Y;
  end;

  procedure TDraw2D.PutPixel(X:TPixel;Color:Byte);
  begin
      PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[X[2]];
      PointOnScanRow[X[1]]:=Color;
  end;

  procedure TDraw2D.PixelLine(X,Y:TPixel;Color:Byte);
  var p,p1,p2,Dx,Dy,i       :Integer;
      M                     :TPixel;
      Position              :Byte;
  Begin
  With Image1 do
  if (X[1]<0) or (X[1]>Width) or (X[2]<0) or (X[2]>Height) or
     (Y[1]<0) or (Y[1]>Width) or (Y[2]<0) or (Y[2]>Height) then exit;
  Dx:=Y[1]-X[1];
  if Dx<0 then
       begin
             p:=X[1];X[1]:=Y[1];Y[1]:=p;
             p:=X[2];X[2]:=Y[2];Y[2]:=p;
             Dx:=-Dx;
       end;
  Dy:=Y[2]-X[2];M[1]:=X[1];M[2]:=X[2];
  PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
  PointOnScanRow[M[1]]:=Color;
  if Dx=0 then
           if Dy>0 then Position:=1
                   else Position:=2
          else
           if Dy=0 then Position:=9
            else
            if Dy=Dx then Position:=3
                    else
                     if Dy=-Dx then Position:=4
                               else
                               if Dy>0 then
                                       if Dy>Dx then Position:=5
                                                 else Position:=6
                                        else
                                         if -Dy>Dx then Position:=7
                                                   else Position:=8;
 Case Position of
  1: For i:=succ(X[2]) to Y[2] do
            begin
              PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[i];
              PointOnScanRow[M[1]]:=Color;
            end;
  2: For i:=succ(Y[2]) to X[2] do
            begin
              PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[i];
              PointOnScanRow[M[1]]:=Color;
            end;
  3: For i:=succ(X[1]) to Y[1] do
            begin
              PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
              PointOnScanRow[i]:=Color;
              inc(M[2]);
            end;
  4: For i:=succ(X[1]) to Y[1] do
           begin
             PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
             PointOnScanRow[i]:=Color;
             dec(M[2]);
           end;
  5: begin
       p:=Dx;Dx:=Dy;Dy:=p;
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;
       While M[2]<Y[2] do
       begin
        Inc(M[2]);
        if p>0 then begin
                       Inc(M[1]);p:=p+p2;
                    end
                    else       p:=p+p1;
        PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
        PointOnScanRow[M[1]]:=Color;
      end;
     end;
  6: begin
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
       While M[1]<Y[1] do
       begin
        inc(M[1]);
        if p>0 then begin
                      inc(M[2]);p:=p+p2;
                      PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
                    end
                    else  p:=p+p1;
        PointOnScanRow[M[1]]:=Color;
       end;
      end;
  7: begin
       p:=Dx;Dx:=Dy;Dy:=-p;
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;
       While M[2]>Y[2] do
       begin
        dec(M[2]);
        if p<0 then begin
                     inc(M[1]);p:=p+p2;
                    end
                    else       p:=p+p1;
        PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
        PointOnScanRow[M[1]]:=Color;
      end;
     end;
  8: begin
       Dy:=-Dy;PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;
       While M[1]<Y[1] do
       begin
        inc(M[1]);
        if p>0 then begin
                      dec(M[2]);
                      p:=p+p2;
                      PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
                    end
                    else  p:=p+p1;
        PointOnScanRow[M[1]]:=Color;
       end;
     end;
   9:begin
      PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
      For i:=succ(X[1]) to Y[1] do PointOnScanRow[i]:=Color;
    end;
  end;
end;

Procedure TDraw2D.Cross(X:TPoint;Size,Color:Byte);
var Pixel,A,B,C,D:TPixel;
begin
   Pixel[1]:=XCoor(X[1]);Pixel[2]:=YCoor(X[2]);
    if (Pixel[1]>=Size) and (Pixel[1]<Image1.Width-Size) and
       (Pixel[2]>=Size) and (Pixel[2]<Image1.Height-Size) then
   begin
   A[1]:=Pixel[1]-Size;A[2]:=Pixel[2];
   B[1]:=Pixel[1]+Size;B[2]:=Pixel[2];
   C[1]:=Pixel[1];  C[2]:=Pixel[2]-Size;
   D[1]:=Pixel[1];  D[2]:=Pixel[2]+Size;
   PixelLine(A,B,Color);
   PixelLine(C,D,Color);
   Image1.Repaint;
   end;
end;

 procedure TDraw2D.Line(X,Y:TPoint;Color:Byte);
  var A,B  :TPixel;
  begin
     A[1]:=XCoor(X[1]);A[2]:=YCoor(X[2]);
     B[1]:=XCoor(Y[1]);B[2]:=YCoor(Y[2]);
     PixelLine(A,B,Color);
  end;

 procedure TDraw2D.PolyLine(X:TArrayOfPoints;n:Word;Color:Byte);
 var i:Word;
     A,B:TPixel;
 begin
   A[1]:=XCoor(X[0,1]);A[2]:=YCoor(X[0,2]);
   for i:=1 to n-1 do
   begin
     B[1]:=XCoor(X[i,1]);B[2]:=YCoor(X[i,2]);
    if (A[1]>=0) and (A[1]<Image1.Width) and
       (A[2]>=0) and (A[2]<Image1.Height) and
       (B[1]>=0) and (B[1]<Image1.Width) and
       (B[2]>=0) and (B[2]<Image1.Height) then
            PixelLine(A,B,Color);
    A:=B;
   end;
   Image1.Repaint;
 end;

procedure TDraw2D.BeziereCurve(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var  t,ht:Real;
     i:Integer;
     A: TArrayOfPoints;

Procedure Bezi(t:Real;var A:TPoint);
begin
   A[1]:=P[0,1]*(1-t)*(1-t)*(1-t)+P[1,1]*3*t*(1-t)*(1-t)
             +P[2,1]*3*t*t*(1-t)+P[3,1]*t*t*t;
   A[2]:=P[0,2]*(1-t)*(1-t)*(1-t)+P[1,2]*3*t*(1-t)*(1-t)
             +P[2,2]*3*t*t*(1-t)+P[3,2]*t*t*t;
end;

Procedure ConstructOfBeziCurve;
begin
  With Image1.Canvas do
  begin
    Line(P[0],P[1],slRed);
    Line(P[1],P[2],slRed);
    Line(P[2],P[3],slRed);   { kresba dicho polygonu }
  end;
  ht:=0.01;
  t:=0;i:=0;
  While t<1 do
  begin
    Bezi(t,A[i]);i:=succ(i);t:=t+ht;
  end;
  PolyLine(A,i-1,slGreen);
end;

begin
  index:=succ(Index);
  P[index,1]:=InvXCoor(x);
  P[index,2]:=InvYCoor(y);
  Cross(P[index],5,slBlue);
  if index=3 then
     begin
      ConstructOfBeziCurve;
      if FirstArc then
         begin
          P[0]:=P[3];
          P[1,1]:=2*P[0,1]-P[2,1];
          P[1,2]:=2*P[0,2]-P[2,2];
          Cross(P[1],5,slBlue);
          Index:=1;
         end
     end;
end;

procedure TDraw2D.ClearData(Sender: TObject);
begin
  x1:=-5;x2:=150;y1:=-10;y2:=300;Scale(x1,x2,y1,y2);
  index:=-1;FirstArc:=True;
end;

procedure TDraw2D.SetBeziere(Sender: TObject);
begin
  InitImage(500,500);ClearImage(slWhite);FirstArc:=True;
  x1:=-5;x2:=150;y1:=-10;y2:=300;Scale(x1,x2,y1,y2);
  index:=-1;
end;

end.
